#include <pybind11/pybind11.h>
#include <pybind11/stl.h>
#include "aidge/data/DataProvider.hpp"
#include "aidge/data/Database.hpp"

namespace py = pybind11;
namespace Aidge {

void init_DataProvider(py::module& m){

    py::class_<DataProvider, std::shared_ptr<DataProvider>>(m, "DataProvider")
          .def(py::init<Database&, std::size_t>(), py::arg("database"), py::arg("batchSize"))
          .def("read_batch", &DataProvider::readBatch, py::arg("start_index"),
          R"mydelimiter(
          Return a batch of each data modality.

          :param start_index: Database starting index to read the batch from
          :type start_index: int
          )mydelimiter");
    
}
}
